///////////////////////////////////////////////////////////////////////////////////////////////////
//
//	D3D Projection shadow  .
//
//		Author: (epochs@nownuri.net)
//			    modified by Gamza
//		
//		ҽ   Բ ֽϴ.
//		 ҽ ؽ ̴  ϼ̾µ,
//		İ ...   ߱ 
//		ؽ ̴ Ⱦ  Ͽϴ.
//		׷ ׷ ؽĿ  µ,
//		ؽ ؼ ϴ κ εο  ȵư ±.
//		.... ϰ ؼ ¸   ٶ...
//			
//			 ø...@~
//		
//		MAIL:Gamza@hitel.net
//		HOME:http://www.Gamza.net
//		
///////////////////////////////////////////////////////////////////////////////////////////////////
#include <windows.h>
#include <d3dx9.h>
#include <stdio.h>

#pragma comment(lib, "d3dx9")
#pragma comment(lib, "d3d9")
#pragma comment(lib, "winmm")
#define SAFE_RELEASE(p)      { if(p) { (p)->Release(); (p)=NULL; } }

// D3D Device
LPDIRECT3D9             g_pD3D           = NULL;
LPDIRECT3DDEVICE9       g_pd3dDevice     = NULL;

// Renderable texture
LPD3DXRENDERTOSURFACE   g_pRenderToSurface = NULL;
LPDIRECT3DSURFACE9      g_pShadowSurface   = NULL;
LPDIRECT3DTEXTURE9      g_pShadowTexture   = NULL; 

// D3DMesh - Blocker, Light, ׸  ü..
D3DLIGHT9				g_Light;
LPD3DXMESH              g_pTeapot = NULL;
LPD3DXMESH              g_pLight  = NULL;
LPD3DXMESH              g_pGround = NULL;
LPD3DXMESH              g_pTorus  = NULL;

// World position - Camera, Blocker, Light
D3DXVECTOR3 g_VCamera (20.0f,15.0f,30.0f);
D3DXVECTOR3 g_VBlocker( 5.0f, 5.0f, 0.0f);
D3DXVECTOR3 g_VLight;

void Render()
{
	///////////////////////////////////////////////////////////////////////////////////////////////////
	//
	//  ġ  ϴ. (....;;)
	//
	///////////////////////////////////////////////////////////////////////////////////////////////////
	{
		static float angle=0;
		const float dangle = 1;
		const float radius = 40;
		angle += (dangle*3.14f/180);		
		g_VLight.x = g_VBlocker.x + 1 + (float)(4 * cos( angle ));
		g_VLight.y = g_VBlocker.y + 3;
		g_VLight.z = g_VBlocker.z + 2 + (float)(4 * sin( angle ));

	    g_Light.Position = g_VLight;
		g_pd3dDevice->SetLight( 0, &g_Light );
	}

	///////////////////////////////////////////////////////////////////////////////////////////////////
	//
	// [׸ ü ǥ] -> [ؽ ǥ] ȯ  ĵ .
	//
	///////////////////////////////////////////////////////////////////////////////////////////////////
    D3DXMATRIX matLocalToWorld; // [0] ׸ ü ǥ -> 
	D3DXMATRIX matWorldToLight; // [1]              ->  ǥ
	D3DXMATRIX matShadowProj;   // [3]  ǥ        -> ؽ ǥ
	///////////////////////////////////////////////////////////////////////////////////////////////////
	D3DXMatrixTranslation( &matLocalToWorld, g_VBlocker.x, g_VBlocker.y, g_VBlocker.z );

	D3DXMatrixLookAtLH( &matWorldToLight, &g_VLight, &g_VBlocker, &D3DXVECTOR3(0.0f,1.0f,0.0f));

	float fXMax = 0.0f; //ִ밪 Ұ̹Ƿ 0 ϸ ȴ.
	float fYMax = 0.0f;
	{
		// ü ؽĿ    FOV Ѵ.
		// [׸ ü ǥ]  [ ǥ] ȯѴ  FOV س.
		DWORD fvfsize = D3DXGetFVFVertexSize(g_pTeapot->GetFVF());
		int nFVF = 0;
		if( g_pTeapot->GetFVF() | D3DFVF_XYZ ) nFVF++;
		if( g_pTeapot->GetFVF() | D3DFVF_NORMAL ) nFVF++;
		int cVertices = g_pTeapot->GetNumVertices(), i;
		BYTE *pbPoints,*pbCur;
		D3DXVECTOR3 *pvCur;
		D3DXVECTOR4 VOut;
		g_pTeapot->LockVertexBuffer(0, (void **)&pbPoints);

		D3DXMATRIX matLocalToLight; // [׸ ü ǥ] -> [ ǥ] 
		D3DXMatrixMultiply( &matLocalToLight, &matLocalToWorld, &matWorldToLight );

		for( i = 0, pbCur = pbPoints ; i < cVertices ; i++, pbCur += fvfsize)
		{
			pvCur = (D3DXVECTOR3*)pbCur;
			D3DXVec3Transform( &VOut, pvCur, &matLocalToLight );

			if((float)fabs(VOut.x/VOut.z) > fXMax) fXMax = (float)fabs(VOut.x/VOut.z);
			if((float)fabs(VOut.y/VOut.z) > fYMax) fYMax = (float)fabs(VOut.y/VOut.z);
		}
		g_pTeapot->UnlockVertexBuffer();
	}
	D3DXMatrixPerspectiveFovLH( &matShadowProj, D3DX_PI/4, 1.0f, 1.0f, 1000.0f );
	matShadowProj.m[0][0] = 0.98f/fXMax;
	matShadowProj.m[1][1] = 0.98f/fYMax;

	///////////////////////////////////////////////////////////////////////////////////////////////////
	//
	//  Renderable texture  ׸ ü 
	//
	///////////////////////////////////////////////////////////////////////////////////////////////////
	g_pRenderToSurface->BeginScene(g_pShadowSurface,NULL);
	g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET , D3DCOLOR_ARGB(0,255,255,255), 0, 0 );
	
	g_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, FALSE);
	g_pd3dDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );
	g_pd3dDevice->SetRenderState( D3DRS_ZENABLE, D3DZB_FALSE );

	// TEXTUREFACTOR   ؼ ܻ  Ұ.
	g_pd3dDevice->SetTexture(0,NULL);
	g_pd3dDevice->SetRenderState( D3DRS_TEXTUREFACTOR, D3DCOLOR_ARGB(255,128,128,128) );
	g_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TFACTOR );
	g_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1 );
	g_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TFACTOR);
	g_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP, D3DTOP_SELECTARG1);

	// ȯ  .
	// [׸ ü ǥ] -> [ǥ] -> [ǥ] -> [ؽ ǥ]
	g_pd3dDevice->SetTransform( D3DTS_WORLD, &matLocalToWorld );
	g_pd3dDevice->SetTransform( D3DTS_VIEW, &matWorldToLight );
	g_pd3dDevice->SetTransform( D3DTS_PROJECTION, &matShadowProj );
	
	// .
	g_pd3dDevice->SetFVF( g_pTeapot->GetFVF() );
	g_pTeapot->DrawSubset(0);
	g_pRenderToSurface->EndScene(D3DX_FILTER_POINT);

	//  ȭ鿡 ׷.
	g_pd3dDevice->BeginScene();
	g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(80,80,255), 1.0f, 0 );
	///////////////////////////////////////////////////////////////////////////////////////////////////
	//
	//  ׸    ׽Ʈ .
	//
	///////////////////////////////////////////////////////////////////////////////////////////////////
	float vertex2D[4][4+2] = 
	{
		{   0,  0,0,1, 0,0 },
		{ 128,  0,0,1, 1,0 },
		{ 128,128,0,1, 1,1 },
		{   0,128,0,1, 0,1 },
	};
	g_pd3dDevice->SetTexture(0,g_pShadowTexture);
	g_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
	g_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP, D3DTOP_SELECTARG1);
	g_pd3dDevice->SetFVF( D3DFVF_XYZRHW|D3DFVF_TEX1 );
	g_pd3dDevice->DrawPrimitiveUP(D3DPT_TRIANGLEFAN,2,vertex2D,sizeof(float)*(4+2));

	///////////////////////////////////////////////////////////////////////////////////////////////////
	//
	//  3D   ⺻غ.
	//
	///////////////////////////////////////////////////////////////////////////////////////////////////
	g_pd3dDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_CCW );

	// ī޶ 
	D3DXMATRIX matView;
	D3DXMatrixLookAtLH( &matView, &g_VCamera,
                                  &D3DXVECTOR3( 0.0f, 0.0f, 0.0f ),
                                  &D3DXVECTOR3( 0.0f, 1.0f, 0.0f ) );
	g_pd3dDevice->SetTransform( D3DTS_VIEW, &matView );

	//  
	D3DXMATRIX matProj;
    D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, 1.0f, 1.0f, 1000.0f );
	g_pd3dDevice->SetTransform( D3DTS_PROJECTION, &matProj );
	
	///////////////////////////////////////////////////////////////////////////////////////////////////
	//
	// ؽ 
	//
	// [׸  ü ǥ] -> [ؽ ǥ]ȯ .
	//
	// ؽ ̴ ٸ İ ѹ .
	// matLocalToWorld = 庯ȯ(׸ Űü);
	// matShadowUV = matLocalToWorld * matWorldToLight * matShadowProj * (scale * offset)
	// c5,6,7,8 matShadowUV 
	// m4x4 oT1, v0, c5
	// 
	// ׷...ؽ ̴ Ⱦ  ٸ.
	// D3D ؽ Ŀ Է ־ ִ° [ī޶ ǥ]̱⶧.
	// Է ٸ ĵ  ٸ.
	// matShadowUV = matCameraToWorld * matWorldToLight * matShadowProj * (scale * offset)
	// SetTransform( &matShadowUV )
	///////////////////////////////////////////////////////////////////////////////////////////////////
	D3DXMATRIX matShadowUV; // [׸  ü ǥ] -> [ؽ ǥ]

    D3DXMATRIX matCameraToWorld;// [ī޶ ǥ] -> [ ǥ]
	D3DXMatrixInverse( &matCameraToWorld, NULL, &matView );
	
	// [׸ ü ǥ] -> [ؽ ǥ]ȯ(matShadowProj)
	// ǥ -1 ~ +1  ȯ߾,
	// ̹ 0 ~ +1  ȯؾ ϱ⶧ 
	// 0.5 ϸѵ 0.5ŭ  ɾ־ .
	D3DXMATRIX scale,offset;
	D3DXMatrixScaling( &scale, 0.5f, -0.5f, 1.0f );
	D3DXMatrixTranslation( &offset, 0.5f, 0.5f, 0.0f );

	D3DXMatrixMultiply( &matShadowUV, &matCameraToWorld, &matWorldToLight );
	D3DXMatrixMultiply( &matShadowUV, &matShadowUV, &matShadowProj );
	D3DXMatrixMultiply( &matShadowUV, &matShadowUV, &scale );
	D3DXMatrixMultiply( &matShadowUV, &matShadowUV, &offset );

	// ī޶ ǥ ؽǥ ؽ  Է .
	g_pd3dDevice->SetTextureStageState( 1, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_CAMERASPACEPOSITION );
	// ǥ ؽ ȯ  ϵ ش. 
	// ̷ ؾ D3D  (projection divide) Ѵ.
	g_pd3dDevice->SetTextureStageState( 1, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT4|D3DTTFF_PROJECTED );
	// ؽ  .
	g_pd3dDevice->SetTransform( D3DTS_TEXTURE1, &matShadowUV );

	///////////////////////////////////////////////////////////////////////////////////////////////////
	//
	//  3D .
	//
	///////////////////////////////////////////////////////////////////////////////////////////////////
	g_pd3dDevice->SetTexture(0,NULL);
	g_pd3dDevice->SetTexture(1,g_pShadowTexture);
	g_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	g_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
	g_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP, D3DTOP_MODULATE );
	g_pd3dDevice->SetTextureStageState( 1, D3DTSS_COLORARG1,D3DTA_TEXTURE);
	g_pd3dDevice->SetTextureStageState( 1, D3DTSS_COLORARG2,D3DTA_CURRENT);
	g_pd3dDevice->SetTextureStageState( 1, D3DTSS_COLOROP,D3DTOP_MODULATE );
	g_pd3dDevice->SetSamplerState( 1, D3DSAMP_ADDRESSU, D3DTADDRESS_CLAMP);
	g_pd3dDevice->SetSamplerState( 1, D3DSAMP_ADDRESSV, D3DTADDRESS_CLAMP);
	g_pd3dDevice->SetSamplerState( 1, D3DSAMP_ADDRESSW, D3DTADDRESS_CLAMP);

	//  Ʈ -> ȯ   ӽú.
	D3DXMATRIX matLocal;
	D3DXMatrixRotationX( &matLocal,	-90*3.14f/180.0f );	
	g_pd3dDevice->SetTransform( D3DTS_WORLD, &matLocal );

	g_pGround->DrawSubset(0);

	g_pTorus->DrawSubset(0);

	// 
	// ׸ ؽĿ ؽ , Ƽؽ   .
	g_pd3dDevice->SetTexture(1,NULL);
	g_pd3dDevice->SetTextureStageState( 1, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_PASSTHRU );
	g_pd3dDevice->SetTextureStageState( 1, D3DTSS_COLOROP, D3DTOP_DISABLE );
	g_pd3dDevice->SetTextureStageState( 1, D3DTSS_ALPHAOP, D3DTOP_DISABLE );
	D3DXMatrixTranslation( &matLocal, g_VBlocker.x, g_VBlocker.y, g_VBlocker.z );
	g_pd3dDevice->SetTransform( D3DTS_WORLD, &matLocal );
	g_pTeapot->DrawSubset(0);

	// ()
	D3DXMatrixTranslation( &matLocal, g_VLight.x, g_VLight.y, g_VLight.z );
	g_pd3dDevice->SetTransform( D3DTS_WORLD, &matLocal );
	g_pLight->DrawSubset(0);

	g_pd3dDevice->EndScene();   
	g_pd3dDevice->Present( NULL, NULL, NULL, NULL );
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) 
	{
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

VOID Cleanup()
{
	SAFE_RELEASE(g_pTeapot);
	SAFE_RELEASE(g_pLight);
	SAFE_RELEASE(g_pGround);
	SAFE_RELEASE(g_pTorus);

	SAFE_RELEASE(g_pShadowSurface);
	SAFE_RELEASE(g_pShadowTexture);
	SAFE_RELEASE(g_pRenderToSurface);

	SAFE_RELEASE(g_pd3dDevice);
    SAFE_RELEASE(g_pD3D);
}

HRESULT InitD3D( HWND hWnd )
{
	// D3D ʱȭ.
    if( NULL == ( g_pD3D = Direct3DCreate9( D3D_SDK_VERSION ) ) )
        return E_FAIL;

    D3DDISPLAYMODE d3ddm;
    if( FAILED( g_pD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &d3ddm ) ) )
        return E_FAIL;

    D3DPRESENT_PARAMETERS d3dpp; 
    ZeroMemory( &d3dpp, sizeof(d3dpp) );
    d3dpp.Windowed = TRUE;
    d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    d3dpp.BackBufferFormat = d3ddm.Format;
    d3dpp.EnableAutoDepthStencil = TRUE;
    d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
    if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
                                      D3DCREATE_SOFTWARE_VERTEXPROCESSING ,
                                      &d3dpp, &g_pd3dDevice ) ) )
    {
        return E_FAIL;
    }
	
	// Renderable texture .
	D3DXCreateRenderToSurface(g_pd3dDevice, 128,128,d3ddm.Format,FALSE,D3DFMT_UNKNOWN,&g_pRenderToSurface);
	D3DXCreateTexture(g_pd3dDevice, 128, 128, 0, D3DUSAGE_RENDERTARGET, d3ddm.Format,  D3DPOOL_DEFAULT, &g_pShadowTexture);
	g_pShadowTexture->GetSurfaceLevel(0, &g_pShadowSurface);

    // Set up a material for light
    D3DMATERIAL9 mtrl;
    ZeroMemory( &mtrl, sizeof(D3DMATERIAL9) );
    mtrl.Diffuse.r = mtrl.Ambient.r = 1.0f;
    mtrl.Diffuse.g = mtrl.Ambient.g = 1.0f;
    mtrl.Diffuse.b = mtrl.Ambient.b = 1.0f;
    mtrl.Diffuse.a = mtrl.Ambient.a = 1.0f;
    g_pd3dDevice->SetMaterial( &mtrl );

	// light
    ZeroMemory( &g_Light, sizeof(g_Light) );
	g_Light.Type         = D3DLIGHT_POINT;
    g_Light.Diffuse.r    = 0.8f;
    g_Light.Diffuse.g    = 0.8f;
    g_Light.Diffuse.b    = 1.0f;
    g_Light.Range        = FLT_MAX;//100.0f;
    //g_Light.Position     = g_VLight;
    g_Light.Attenuation1 = 0.4f;
	g_pd3dDevice->SetRenderState( D3DRS_LIGHTING , TRUE );
	g_pd3dDevice->LightEnable( 0, TRUE );
	//g_pd3dDevice->SetLight( 0, &g_Light );
    g_pd3dDevice->SetRenderState( D3DRS_AMBIENT, 
        D3DCOLOR_COLORVALUE( 0.25, 0.25, 0.25, 1.0 ) );

	// ġ ǥ ü  ׸ڸ 帮  .
	D3DXCreateSphere(g_pd3dDevice, 0.2f, 5, 5, &g_pLight, NULL );
	D3DXCreateTeapot(g_pd3dDevice, &g_pTeapot, NULL);
	D3DXCreatePolygon(g_pd3dDevice, 20.0f, 4, &g_pGround, NULL );
	D3DXCreateTorus(g_pd3dDevice,1,5,10,20, &g_pTorus,NULL);

	D3DXComputeNormals( g_pLight, NULL );
	D3DXComputeNormals( g_pTeapot, NULL );
	D3DXComputeNormals( g_pTorus, NULL );

    return S_OK;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	HWND hWnd;
	WNDCLASSEX wcex;
	MSG msg;

	wcex.cbSize = sizeof(WNDCLASSEX); 
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, NULL);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= "ProjectionShadowDX9";
	wcex.lpszClassName	= "ProjectionShadowDX9";
	wcex.hIconSm		= LoadIcon(wcex.hInstance, NULL);

	RegisterClassEx(&wcex);

	hWnd = CreateWindow("ProjectionShadowDX9", "TProjectionShadowDX9", WS_OVERLAPPEDWINDOW,
	0, 0, 600, 600, NULL, NULL, hInstance, NULL);

	InitD3D( hWnd );

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	// Main message loop:
	while(1)
	{
		if(PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE))
		{
			if(!GetMessage(&msg,NULL, 0, 0)) break;
			TranslateMessage (&msg) ;
			DispatchMessage (&msg) ;
		}
		else
		{
			Render();
		}
	}

	Cleanup();

	return msg.wParam;
}

